///////////////////////////////////////////////////////////////
// The PC Benchmark (pcb)
// (c) 2015, Marko Oette (www.oette.info)
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.
//

#include "plattform.h"
#include <assert.h>

// test setup
const unsigned int 	TEST_CYCLES			= 5;					// How often to repeat the tests

#if (BITNESS == 16)
const size_t 		MEMCPY_BLOCK_SIZE	= 63;  					// 63 KiByte blocks	(limit of size_t)
#elif (BITNESS == 32)
const size_t 		MEMCPY_BLOCK_SIZE	= 1024;  				// 1 MiByte blocks
#elif (BITNESS == 64)
const size_t 		MEMCPY_BLOCK_SIZE	= 1024;		  			// 1 MiByte blocks
#endif


const size_t 		DISK_BLOCK_SIZE		= 10*1024;				// 10 KByte blocks
const int 			DISK_MBYTE			= 50;					// Write 50 MByte

// forward defines
// TEST-Syntax is: int FUNC( LNG_TYPE, LNG_TYPE, void* buf )
int WaitTest(LNG_TYPE ops, LNG_TYPE dummy, const void*);
int Calibrate(LNG_TYPE, LNG_TYPE, const void* buf);
int MeasureIOPS( LNG_TYPE, LNG_TYPE, const void* buf );
int MeasureFLOPS( LNG_TYPE, LNG_TYPE, const void* buf );
int MeasureBitShifting( LNG_TYPE, LNG_TYPE, const void* buf );
int MeasureFloatingMath( LNG_TYPE, LNG_TYPE, const void* buf );
int ApproximateMemCpy(LNG_TYPE ops, LNG_TYPE kibytes, const void* buf);
int ApproximateMemSet(LNG_TYPE ops, LNG_TYPE bytes, const void* buf);
int ApproximateDiskWriteSpeed(LNG_TYPE mbytes, LNG_TYPE kibytes, const void* buf);
